import styled from 'styled-components';

export const Banner = styled.div`{
  padding:20px 25px;
  color:#333;
  font-size:18px;
  border-bottom:1px solid #eee;
  background-color:#fff;
  border-radius:5px 5px 0px 0px;
}`
export const AlignCenterBetween = styled.div`{
  display:flex;
  align-items: center;
  padding: 14px 14px 14px 20px;
  justify-content: space-between;
  border-bottom:1px solid #eee;
}`
export const FlexAJ = styled.div`{
  display:flex;
  align-items: center;
  justify-content: space-between;
}`
export const AlignCenter = styled.div`{
  display:flex;
  align-items: center;
}`
// 左右结构
export const Box = styled.div`{
  display:flex;
  align-item:flex-start;
}`
export const Long = styled.div`{
  width:72%;
  border-radius:5px;
  margin-bottom:30px;
}`
export const Short = styled.div`{
  width:28%;
  border-radius:5px;
  margin-bottom:30px;
}`
export const Gap = styled.div`{
  padding-left:20px;
  box-sizing:border-box;
}`
export const WhiteBack = styled.div`{
  background-color:#fff;
  border-radius:5px;
}`
export const Blueline = styled.a`{
  height:30px;
  line-height:28px;
  border-radius:2px;
  border:1px solid rgba(80,145,255,1);
  color:rgba(80,145,255,1);
  padding:0px 12px;
  display:inline-block;
}`
export const Redline = styled.a`{
  height:30px;
  line-height:28px;
  border-radius:2px;
  border:1px solid #F73030;
  color:#F73030;
  padding:0px 12px;
  display:inline-block;
  min-width:80px;
  text-align:center;
}`
export const Greenline = styled.a`{
  height:30px;
  line-height:28px;
  border-radius:2px;
  border:1px solid #28BD6C;
  color:#28BD6C;
  padding:0px 12px;
  display:inline-block;
  min-width:80px;
  text-align:center;
}`
export const Greenback = styled.a`{
  height:30px;
  line-height:30px;
  border-radius:2px;
  background-color:#28BD6C;
  color:#fff;
  padding:0px 12px;
  display:inline-block;
  min-width:80px;
  text-align:center;
}`
export const Blueback = styled.a`{
  height:30px;
  line-height:30px;
  border-radius:2px;
  background-color:rgba(80,145,255,1);
  color:#fff;
  padding:0px 12px;
  display:inline-block;
  min-width:80px;
  text-align:center;
}`
export const Redback = styled.a`{
  height:30px;
  line-height:30px;
  border-radius:2px;
  background-color:#F73030;
  color:#fff;
  padding:0px 12px;
  display:inline-block;
  min-width:80px;
  text-align:center;
}`
export const NumUl = styled.ul`{
  padding-left: 20px;
  & > li{
    list-style-type: decimal;
    color:#888;
    height:24px;
    line-height:24px;
  }
}`
export const GreenUnder = styled.a`{
  color:#28BD6C!important;
  position:relative;
  &:after{
    position:absolute;
    bottom:-2px;
    left:0px;
    width:100%;
    height:1px;
    content:'';
    background:#28BD6C;
  }
}`
export const Cancel = styled.a`{
  height:32px;
  line-height:32px;
  border-radius:2px;
  background-color:#BBBBBB;
  color:#fff;
  padding:0px 12px;
  display:inline-block;
  min-width:64px;
  text-align:center;
  letter-spacing: 4px;
}`
export const Content = styled.div`{
  width:1200px;
  margin:20px auto;
  text-align:center;
  display:flex;
  align-Items:center;
  background-color:#fff;
  justify-content: center;
}`
