import styled from 'styled-components';
import imgs from '../images/userhead.jpg';

export const NewUserMain = styled.div`{
  margin: 0 auto;
  min-width: 1200px;
  padding-top: 60px;
  padding-bottom: 117px;
}`

export const SelectSection = styled.div`{
  padding: 15px;
  margin-top: 15px;
  background: #fff;
  input, button{height: 36px; line-height: 36px;}
  input::placeholder{font-size: 14px;}
}`

export const MainUser = styled.div`{
  width: 100%;
  background: #fff;
  margin-bottom: 20px;
  position: relative;
}`

export const HeadImage = styled.div`{
  width: 100%;
  height: 160px;
  background-image: url('${imgs}');
  position: absolute;
  width: 100%;
  left: 0px;
  top: 0px;
}`

export const HeadCon = styled.div`{
  position: absolute;
  width: 100%;
  left: 0px;
  top: 0px;
  min-height: 356px;
}`

export const IdentifyA = styled.a`{
  width: 20px;
  height: 20px;
  line-height: 20px;
  text-align: center;
  border-radius: 50%;
  background-color: #F4FAFF;
  margin-right: 5px;
}`

export const RelativePos = styled.div`{
  position: relative;
}`

export const DivInline = styled.div`{
  display: inline-block;
  width: auto;
  line-height: 26px;
  font-size: 16px;
}`

export const IdentifyName = styled.span`{
    color: #686868;
    font-size: 14px;
    margin-right: 10px;
}`

export const GridItem5 = styled.div`{
  display: grid;
  grid-template-columns: max-content max-content max-content max-content max-content;
  align-items: center;
}`

export const GridItem2 = styled.div`{
  display: grid;
  grid-template-columns: max-content 1fr;
  align-items: center;
}`
export const Pt80 = styled.div`{
  padding-top: 80px;
}`

export const ShowName = styled.span`{
  display: block;
  width: auto;
  color: #05101A;
  font-size: 24px;
  height: 28px;
  line-height: 28px;
  margin-top: 5px;
  clear: both;
}`

export const HeadPhoto = styled.div`{
  margin-top: 14px;
  text-align: center;
  background: #FFFFff;
  width: 115px;
  height: 115px;
  padding: 3px;
  border-radius: 50%;
  position: relative;
  float: left;
  margin-top: 19px;
  box-sizing: border-box;
}`

export const HeadPhotoHover = styled.div`{
  display: block;
  cursor: pointer;
  position: absolute;
  top: 3px;
  left: 3px;
  width: 109px;
  height: 109px;
  text-align: center;
  line-height: 112px;
  border-radius: 50%;
  background-color: rgba(0,0,0,0.5);
  color: #fff;
  .upload-edit-word{
    color: #fff !important;
  }
}`

export const HeadTab = styled.div`{
  width: 188px;
  height: 60px;
  text-align: center;
  span {
    color: #989898;
    font-size: 14px;
  };
  a {
    color: #fff;
    font-size: 24px;
    line-height: 2;
  };
  span, a{
    {
      display: block;
      width: 100%;
      text-align: center;
    }
  }
}`